"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _del = _interopRequireDefault(require("del"));

var _recursiveCopy = _interopRequireDefault(require("recursive-copy"));

var _mkdirpThen = _interopRequireDefault(require("mkdirp-then"));

var _path = require("path");

var _fs = require("fs");

var _config = _interopRequireDefault(require("./config"));

var _constants = require("../lib/constants");

var _render = require("./render");

var _asset = require("../lib/asset");

var envConfig = _interopRequireWildcard(require("../lib/runtime-config"));

function _default(_x, _x2, _x3) {
  return _ref.apply(this, arguments);
}

function _ref() {
  _ref = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(dir, options, configuration) {
    var nextConfig, distDir, buildId, pagesManifest, pages, defaultPathMap, _i, page, outDir, renderOpts, serverRuntimeConfig, publicRuntimeConfig, exportPathMap, exportPaths, _i2, path, _exportPathMap$path, _page, _exportPathMap$path$q, query, req, res, htmlFilename, baseDir, htmlFilepath, html, log;

    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            log = function _ref3(message) {
              if (options.silent) return;
              console.log(message);
            };

            dir = (0, _path.resolve)(dir);
            nextConfig = configuration || (0, _config.default)(_constants.PHASE_EXPORT, dir);
            distDir = (0, _path.join)(dir, nextConfig.distDir);
            log("> using build directory: ".concat(distDir));

            if ((0, _fs.existsSync)(distDir)) {
              _context2.next = 7;
              break;
            }

            throw new Error("Build directory ".concat(distDir, " does not exist. Make sure you run \"next build\" before running \"next start\" or \"next export\"."));

          case 7:
            buildId = (0, _fs.readFileSync)((0, _path.join)(distDir, _constants.BUILD_ID_FILE), 'utf8');
            pagesManifest = require((0, _path.join)(distDir, _constants.SERVER_DIRECTORY, _constants.PAGES_MANIFEST));
            pages = Object.keys(pagesManifest);
            defaultPathMap = {};
            _i = 0;

          case 12:
            if (!(_i < pages.length)) {
              _context2.next = 20;
              break;
            }

            page = pages[_i];

            if (!(page === '/_document' || page === '/_app')) {
              _context2.next = 16;
              break;
            }

            return _context2.abrupt("continue", 17);

          case 16:
            defaultPathMap[page] = {
              page: page
            };

          case 17:
            _i++;
            _context2.next = 12;
            break;

          case 20:
            // Initialize the output directory
            outDir = options.outdir;
            _context2.next = 23;
            return (0, _del.default)((0, _path.join)(outDir, '*'));

          case 23:
            _context2.next = 25;
            return (0, _mkdirpThen.default)((0, _path.join)(outDir, '_next', buildId));

          case 25:
            if (!(0, _fs.existsSync)((0, _path.join)(dir, 'static'))) {
              _context2.next = 29;
              break;
            }

            log('  copying "static" directory');
            _context2.next = 29;
            return (0, _recursiveCopy.default)((0, _path.join)(dir, 'static'), (0, _path.join)(outDir, 'static'), {
              expand: true
            });

          case 29:
            if (!(0, _fs.existsSync)((0, _path.join)(distDir, _constants.CLIENT_STATIC_FILES_PATH))) {
              _context2.next = 33;
              break;
            }

            log('  copying "static build" directory');
            _context2.next = 33;
            return (0, _recursiveCopy.default)((0, _path.join)(distDir, _constants.CLIENT_STATIC_FILES_PATH), (0, _path.join)(outDir, '_next', _constants.CLIENT_STATIC_FILES_PATH));

          case 33:
            if (!(0, _fs.existsSync)((0, _path.join)(distDir, 'chunks'))) {
              _context2.next = 39;
              break;
            }

            log('  copying dynamic import chunks');
            _context2.next = 37;
            return (0, _mkdirpThen.default)((0, _path.join)(outDir, '_next', 'webpack'));

          case 37:
            _context2.next = 39;
            return (0, _recursiveCopy.default)((0, _path.join)(distDir, 'chunks'), (0, _path.join)(outDir, '_next', 'webpack', 'chunks'));

          case 39:
            // Get the exportPathMap from the config file
            if (typeof nextConfig.exportPathMap !== 'function') {
              console.log("> No \"exportPathMap\" found in \"".concat(_constants.CONFIG_FILE, "\". Generating map from \"./pages\""));

              nextConfig.exportPathMap =
              /*#__PURE__*/
              function () {
                var _ref2 = (0, _asyncToGenerator2.default)(
                /*#__PURE__*/
                _regenerator.default.mark(function _callee(defaultMap) {
                  return _regenerator.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          return _context.abrupt("return", defaultMap);

                        case 1:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee, this);
                }));

                return function (_x4) {
                  return _ref2.apply(this, arguments);
                };
              }();
            } // Start the rendering process


            renderOpts = {
              dir: dir,
              buildId: buildId,
              nextExport: true,
              assetPrefix: nextConfig.assetPrefix.replace(/\/$/, ''),
              distDir: distDir,
              dev: false,
              staticMarkup: false,
              hotReloader: null
            };
            serverRuntimeConfig = nextConfig.serverRuntimeConfig, publicRuntimeConfig = nextConfig.publicRuntimeConfig;

            if (publicRuntimeConfig) {
              renderOpts.runtimeConfig = publicRuntimeConfig;
            }

            envConfig.setConfig({
              serverRuntimeConfig: serverRuntimeConfig,
              publicRuntimeConfig: publicRuntimeConfig
            }); // set the assetPrefix to use for 'next/asset'

            (0, _asset.setAssetPrefix)(renderOpts.assetPrefix); // We need this for server rendering the Link component.

            global.__NEXT_DATA__ = {
              nextExport: true
            };
            _context2.next = 48;
            return nextConfig.exportPathMap(defaultPathMap);

          case 48:
            exportPathMap = _context2.sent;
            exportPaths = Object.keys(exportPathMap);
            _i2 = 0;

          case 51:
            if (!(_i2 < exportPaths.length)) {
              _context2.next = 72;
              break;
            }

            path = exportPaths[_i2];
            log("> exporting path: ".concat(path));

            if (path.startsWith('/')) {
              _context2.next = 56;
              break;
            }

            throw new Error("path \"".concat(path, "\" doesn't start with a backslash"));

          case 56:
            _exportPathMap$path = exportPathMap[path], _page = _exportPathMap$path.page, _exportPathMap$path$q = _exportPathMap$path.query, query = _exportPathMap$path$q === void 0 ? {} : _exportPathMap$path$q;
            req = {
              url: path
            };
            res = {};
            htmlFilename = "".concat(path).concat(_path.sep, "index.html");

            if ((0, _path.extname)(path) !== '') {
              // If the path has an extension, use that as the filename instead
              htmlFilename = path;
            } else if (path === '/') {
              // If the path is the root, just use index.html
              htmlFilename = 'index.html';
            }

            baseDir = (0, _path.join)(outDir, (0, _path.dirname)(htmlFilename));
            htmlFilepath = (0, _path.join)(outDir, htmlFilename);
            _context2.next = 65;
            return (0, _mkdirpThen.default)(baseDir);

          case 65:
            _context2.next = 67;
            return (0, _render.renderToHTML)(req, res, _page, query, renderOpts);

          case 67:
            html = _context2.sent;
            (0, _fs.writeFileSync)(htmlFilepath, html, 'utf8');

          case 69:
            _i2++;
            _context2.next = 51;
            break;

          case 72:
            // Add an empty line to the console for the better readability.
            log('');

          case 73:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return _ref.apply(this, arguments);
}